<?php
 


class Limex_Advr_Model_System_Config_Source_Category extends Varien_Object
{
    public function toOptionArray($empty = false)
    {
        $size = Mage::getModel('catalog/category')->getCollection()->getSize();
        if ($size > 100) {
            return false;
        }

        $list = $this->getTreeCategories(Mage::app()->getStore()->getRootCategoryId());

        $result = array();

        if ($empty) {
            $result[''] = '-';
        }

        foreach ($list as $value => $label) {
            $result[$value] = $label;
        }

        return $result;
    }

    public function getTreeCategories($parentId)
    {
        $result = array();

        $collection = Mage::getModel('catalog/category')->getCollection()
            ->addAttributeToSelect('name')
            ->addAttributeToFilter('parent_id', array('eq' => $parentId))
            ->addAttributeToSort('position', 'asc')
            ; 
            
        foreach($collection as $category) {
            $result[$category->getId()] = str_repeat('-', $category->getLevel() * 2).$category->getName();
            $childrens = $category->getChildren();
            
            if ($childrens) { 
                $childrens = $this->getTreeCategories($category->getId(), true);
                foreach ($childrens as $k => $v) {
                    $result[$k] = $v;
                }
            }
        }

        return $result;
    }
}